# 🖩 Digital Calculator

Digital Calculator is a fully function Calculator Clone which is based on this [UI Design](https://www.figma.com/file/u5ZUqipus9HDydBEIU1ZSn/Neumorphism-UI-Design-by-%40feedlike-(Community)?node-id=0%3A1).
It has keyboard support and a few useful shortcuts for quick and easy access. It also has a dedicated dark mode theme for better accessibility.

Please star⭐ the repo if you like what you see😊.

## 📸 Screenshots
<img alt="Light Mode Image" src="images/screenshots/app_screenshot_1.png" height="587px" width="256px"/> <img alt="Dark Mode Image" src="images/screenshots/app_screenshot_2.png" height="587px" width="256px"/>
<br/>
<img alt="Responsive Support Image" src="images/screenshots/app_screenshot_3.png" height="587px" width="256px"/> <img alt="Floating Window Image" src="images/screenshots/app_screenshot_4.png" height="587px" width="256px"/>

## 💻 Installation links

<table>
  <tr>
    <th>Platform</th>
    <th>Installation Links</th>
  </tr>
  <tr>
    <td>Android</td>
    <td>
      <a href="https://play.google.com/store/apps/details?id=com.adeeteya.digital_calculator">
        <img height="80" alt="Get it on Google Play" src="https://play.google.com/intl/en_us/badges/static/images/badges/en_badge_web_generic.png">
      </a>
      <br>
      <a href="https://github.com/adeeteya/DigitalCalculator/releases/latest/download/DigitalCalculator-Android.apk">
        <img width="220" alt="APK download" src="https://img.shields.io/static/v1?label=Download&message=Android+.apk&color=2ea44f&style=for-the-badge&logo=Android&logoColor=white&logoSize=auto">
      </a>
    </td>
  </tr>

  <tr>
      <td>Windows</td>
      <td>
        <a href="https://github.com/adeeteya/DigitalCalculator/releases/latest/download/DigitalCalculator-Windows.exe">
          <img width="220" alt="Windows App" src="https://img.shields.io/static/v1?label=Download&message=Windows+App&color=blue&style=for-the-badge&logo=webtrees&logoColor=white&logoSize=auto">
        </a>
      </td>
  </tr>

  <tr>
      <td>Web App</td>
      <td>
        <a href="https://adeeteya.github.io/DigitalCalculator/#/">
          <img width="220" alt="Web App" src="https://img.shields.io/static/v1?label=Webapp&message=Visit+Website&color=blueviolet&style=for-the-badge&logo=googlechrome&logoColor=white&logoSize=auto">
        </a>
      </td>
  </tr>

</table>

## ✨ Features
- [x] Keyboard Support (even for Android and iOS)
- [x] Shortcuts Support
- [x] Digital Display
- [x] Error Handling
- [x] Sign Change
- [x] Floating Window Support
- [x] Light Mode
- [x] Dark Mode
- [x] Responsive Design
- [ ] Scientific Calculator
- [ ] Calculator History

## ⌨ Shortcuts
| Shortcut                                                                                        | Action                    |
|-------------------------------------------------------------------------------------------------|---------------------------|
| ![Digits](images/shortcuts/digits.png)                                                          | Inputs digits from 0 to 9 |
| ![Addition Key](images/shortcuts/addition.png)                                                  | Addition                  |
| ![Subtraction Key](images/shortcuts/subtraction.png)                                            | Subtraction               |
| ![Character X Key](images/shortcuts/x.png) ![Asterisk Key](images/shortcuts/multiplication.png) | Multiplication            |
| ![Forward Slash Key](images/shortcuts/division.png)                                             | Division                  |
| ![Percent Key](images/shortcuts/percent.png)                                                    | Percentage                |
| ![Backspace Key](images/shortcuts/backspace.png)                                                | Delete a Digit            |
| ![Period Key](images/shortcuts/period.png) ![Comma Key](images/shortcuts/comma.png)             | Decimal Point             |
| ![Enter Key](images/shortcuts/enter.png) ![Equal Key](images/shortcuts/equal.png)               | Evaluate                  |
| ![Character c Key](images/shortcuts/c.png)                                                      | All Clear                 |
| ![Escape Key](images/shortcuts/escape.png) ![Delete Key](images/shortcuts/delete.png)           | Clear Character           |

## 🔌 Plugins
| Name                                                                              | Usage                                               |
|-----------------------------------------------------------------------------------|-----------------------------------------------------|
| [**flutter_inset_box_shadow**](https://pub.dev/packages/flutter_inset_box_shadow) | To use inset property for box shadows               |
| [**math_expressions**](https://pub.dev/packages/math_expressions)                 | For parsing and evaluating mathematical expressions |
| [**flutter_lints**](https://pub.dev/packages/flutter_lints)                       | For linting                                         |

## 🤓 Author
**[Aditya R](https://github.com/adeeteya)**

## 🔖 LICENCE
Copyright (c) 2023 Aditya R
[MIT LICENCE](https://github.com/adeeteya/DigitalCalculator/blob/master/LICENSE)

## 🙏 Attributions
<a href="https://www.flaticon.com/free-icons/calculator" title="calculator icons">Calculator icons created by Freepik - Flaticon</a>